#include "lcd.h"

void lcd_init(void)
{
	twi_init();	// Init TWI	
	delay_ms(10);
	lcd_instr(0x38);
	delay_ms(10);
	lcd_instr(0x39);
	delay_ms(10);
	lcd_instr(0x1C);
	delay_ms(10);
	lcd_instr(0x74);
	delay_ms(10);
	lcd_instr(0x5F);
	delay_ms(10);
	lcd_instr(0x6A);
	delay_ms(200);

	
	lcd_instr(0x0C);  
	delay_ms(10);
	lcd_instr(0x01);
	delay_ms(10);
	lcd_instr(0x06);
	delay_ms(10);
	lcd_instr(0x80);
	delay_ms(10);
}

void lcd_instr(unsigned char d)
{
	while(1)
	{
		twi_start(); // Send start condition
		
		SPIF = 0;
		twi_send((0x3E<<1)|(0<<0)); // Send address 0x3E and write bit 
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		SPIF = 0;
		twi_send((0<<Co)|(0<<RS));
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		SPIF = 0;
		twi_send(d);
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		twi_stop();
		break;
	}
}

void lcd_data(unsigned char d)
{
	while(1)
	{
		twi_start(); // Send start condition
		
		SPIF = 0;
		twi_send((0x3E<<1)|(0<<0)); // Send address 0x3E and write bit 
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		SPIF = 0;
		twi_send((0<<Co)|(1<<RS));
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		SPIF = 0;
		twi_send(d);
		while(!SPIF);
		if (twi_read_status() & (1<<1))
		{
			twi_stop();
			delay_ms(1);
			continue;
		}
	
		twi_stop();
		break;
	}
}

void lcd_print(char* d, unsigned char line)
{
	unsigned char i = 0;

	if (line == 0)
		lcd_instr(0x80);
	else
		lcd_instr(0xC0);
	
	delay_ms(1);

	while (d[i] != '\0')
	{
		lcd_data(d[i++]);
		delay_ms(1);
	}
}
