#include "main.h"
							
volatile unsigned char idata RX_HAS_NEW_DATA = 0;
volatile unsigned char idata RX_WRITE_POINTER = 0;
volatile unsigned char idata RX_READ_POINTER = 0;
volatile unsigned char xdata RX_BUFFER[256] = (unsigned char*)0x0000;
					
volatile unsigned char idata TX_PENDING = 0;									  
volatile unsigned char idata TX_WRITE_POINTER = 0;
volatile unsigned char idata TX_READ_POINTER = 0;
volatile unsigned char xdata TX_BUFFER[256] = (unsigned char*)0x0100;

volatile unsigned char idata RF_ON = 0;
volatile unsigned char idata RF_ID = 0xFF;	

extern volatile unsigned char idata rtc_counter;

int main(void)
{
	unsigned char idata i = 0;

	PWRDWN = 1; // Set to DeepSleep
		
	spi_init();	
	rtc_init();	
	rtc_disableWakeUp();

	IEN0 = (1<<7); // Enable global interrupt

	while(1)
	{
		if (RF_ON == 2) // Initialize RF
		{
			rfcomm_init(); // Start RF clocks and interface
			rfcomm_disable_rx_dr_irq();	// Disable RF interrupts
			rfcomm_disable_tx_ds_irq();
			rfcomm_disable_max_rt_irq();
 
			rftrx_reg_write(RFTRX_REG_EN_AA, &i, 1); // No auto ack
			rftrx_reg_write(RFTRX_REG_SETUP_RETR, &i, 1); // No retransmit
			rfcomm_set_speed(RFCOMM_SPEED_2MBPS); // Max speed = 2Mbps
			rfcomm_enable_dynamic_ack(); // Enable no ack command
			rfcomm_set_output_power(RFCOMM_POWER_min18dBm); // Min power = -18dBm

			delay_10us(100);
			rfcomm_power_up(); // Power up RF module
			delay_10us(100);
			rfcomm_receive_mode(); // Set to receive mode
			
			RFCON |= (1<<0); // Enable transceiver

			rtc_counter = 0;

			while(rtc_counter < 20) // Wait 500ms for sync from others
			{
				if (rfcomm_new_rx_data()) // If data received
				{
					
				}
			}
		}	
	}

	

	while(1)
	{	 	
		rfcomm_receive_mode();

		RFCON |= (1<<0);		 
		
		rtc_wait(5);
		
		// RECEIVING
		rtc_wait(68);	
			 
		RFCON &= ~(1<<0);

		rfcomm_transmit_mode();
		rftrx_tx_payload_noack(TX_BUFFER, 32);

		rtc_wait(80);	

		RFCON |= (1<<0);
		delay_10us(1);
		RFCON &= ~(1<<0);

		while(!rfcomm_tx_data_sent());
		rfcomm_clr_tx_data_sent();	
		
		rtc_wait(100);
											  
		PWRDWN = 4; // Memory retention, timers on
		
		do
		{
			RTC2CON |= (1<<4);
		} while (((RTC2CPT01<<8) + RTC2CPT00) > 0);	
	}

	return 0;
}