#ifndef RFCOMM_H_
#define RFCOMM_H_

#include "rftrx.h"

#define RFCOMM_SPEED_250KBPS 	0
#define RFCOMM_SPEED_1MBPS 		1
#define RFCOMM_SPEED_2MBPS 		2

#define RFCOMM_POWER_min18dBm 	0
#define RFCOMM_POWER_min12dBm 	1
#define RFCOMM_POWER_min6dBm 	2
#define RFCOMM_POWER_min0dBm 	3

void rfcomm_init(void);
void rfcomm_set_channel(unsigned char channel);
void rfcomm_set_rx_pipe_address(unsigned char pipe, unsigned char* addr, unsigned char len);
void rfcomm_set_tx_pipe_address(unsigned char* addr, unsigned char len);
void rfcomm_set_address_length(unsigned char len);
void rfcomm_enable_pipe(unsigned char pipe);
void rfcomm_disable_pipe(unsigned char pipe);
void rfcomm_enable_pipe_autoack(unsigned char pipe);
void rfcomm_disable_pipe_autoack(unsigned char pipe);
void rfcomm_set_auto_retransmit_delay(unsigned char del);
void rfcomm_set_auto_retransmit_count(unsigned char num);
void rfcomm_set_speed(unsigned char speed);
void rfcomm_set_output_power(unsigned char rfpwr);
void rfcomm_enable_dynamic_pipe_payload_length(unsigned char pipe);
void rfcomm_disable_dynamic_pipe_payload_length(unsigned char pipe);
void rfcomm_enable_dynamic_payload_length(void);
void rfcomm_disable_dynamic_payload_length(void);
void rfcomm_enable_ack_payload(void);
void rfcomm_disable_ack_payload(void);
void rfcomm_enable_dynamic_ack(void);
void rfcomm_disable_dynamic_ack(void);
void rfcomm_receive_mode(void);
void rfcomm_transmit_mode(void);
void rfcomm_power_up(void);
void rfcomm_power_down(void);
void rfcomm_enable_crc(void);
void rfcomm_disable_crc(void);
void rfcomm_crc_scheme(unsigned char crc);
void rfcomm_enable_rx_dr_irq(void);
void rfcomm_disable_rx_dr_irq(void);
void rfcomm_enable_tx_ds_irq(void);
void rfcomm_disable_tx_ds_irq(void);
void rfcomm_enable_max_rt_irq(void);
void rfcomm_disable_max_rt_irq(void);
unsigned char rfcomm_new_rx_data(void);
void rfcomm_clr_new_rx_data(void);
unsigned char rfcomm_tx_data_sent(void);
void rfcomm_clr_tx_data_sent(void);
unsigned char rfcomm_max_retries(void);
void rfcomm_clr_max_retries(void);
unsigned char rfcomm_pipe_number(void);
unsigned char rfcomm_tx_full(void);

#endif