#include "rtc.h"

volatile unsigned char idata rtc_counter = 0;

void rtc2(void) interrupt 13 using 3  // RTC2 Interrupt (TICK)
{
 	rtc_counter++;
}

void rtc_init(void)
{
	CLKLFCTRL = 0; // Clock LF from XOSC32K
	while(!(CLKLFCTRL&(1<<6)));

	IEN1 = (1<<5); // Enable TICK interrupt

	RTC2CMP0 = 0x20;
	RTC2CMP1 = 0x03;

	RTC2CON = (3<<1)|(1<<0); // Enable RTC2, TICK on compare match and reset timer	  

	WUCON &= ~0x30; // Wakeup on TICK, if interrupt is active
}

void rtc_disableWakeUp(void)
{
	WUCON |= 0x30;
}

void rtc_enableWakeUp(void)
{
	 WUCON &= ~0x30; // Wakeup on TICK, if interrupt is active
}

void rtc_wait(unsigned int wait)
{
	do
	{
		RTC2CON |= (1<<4);
	} while (((RTC2CPT01<<8) + RTC2CPT00) < wait);
}