#include "twi.h"

void twi_init(void)
{
	W2CON0 |= 0x01; // Enable I2C
	W2CON0 |= 0x0A; // Set master mode and speed to 100kHz
	INTEXP |= 0x04; // Enable Interrupt from I2C
	W2CON1 = 0x00; // Disable I2C module interrupts
}

void twi_start(void)
{
	W2CON0 |= (1<<4); // Send start condition
}

void twi_stop(void)
{
	W2CON0 |= (1<<5); // Send stop condition
}

void twi_send(unsigned char d)
{
	W2DAT = d;
}

unsigned char twi_read(void)
{				
	return W2DAT;
}

unsigned char twi_read_status(void)
{
	return W2CON1; // Return ack bit
}